﻿(function (window, undefined) {
  function debounce(method, delay) {
    var timer = null;
    return function () {
      var self = this,
        args = arguments;
      timer && clearTimeout(timer);
      timer = setTimeout(function () {
        method.apply(self, args);
      }, delay);
    };
  }

  function __Broser360_flow_adv() {}
  __Broser360_flow_adv.prototype = {
    divId: "mso_e_browser_container",
    res: null, //广告数据
    addEvent: function () {
      var that = this;
      var items = document.querySelectorAll(".__browser360_flow_adv_item");
      if (items && items.length) {
        for (var i = 0; i < items.length; i++) {
          items[i].addEventListener("click", function (e) {
            //点击
            var id = this.getAttribute("data-id") || "";
            var param = {
              eventX: e.clientX,
              eventY: e.clientY,
              uniqueId: id,
              action: 1,
            };
            console.log(
              "$adOnH5Event(" +
                JSON.stringify(param) +
                ",'__360broser_flow_itemclick_callback')"
            );
          });
        }
      }
      //onscroll
      window.onscroll = debounce(function () {
        that.isInScreen();
      }, 200);
    },
    //点击回调
    itemClickCallback: function (res) {
      // {
      //     "uniqueId":"xxx",
      //     "btnText":"立即下载"
      // }
      if (!res.uniqueId || !res.btnText) {
        return;
      }
      var dom = document.getElementById(
        "__360browser_flow_item_btn_" + res.uniqueId
      );
      if (dom) {
        dom.innerText = res.btnText;
      }
    },
    initHtml: function () {
      // {
      //     "uniqueId":"xxx",
      //     "title":"",
      //     "desc":"",
      //     "imgList":[
      //         "",
      //         "",
      //         ""
      //     ],
      //     "type":1,
      //     "btnText":"立即下载"
      // }

      // type:1 大图
      // type:2 小图
      // type:3 多图
      // type:4 无图
      if (!this.res) {
        return;
      }
      var that = this;
      var list = [];
      if (this.res instanceof Array) {
        list = this.res;
      } else {
        list = [this.res];
      }
      //遍历数组
      var html = "";
      for (var i = 0; i < list.length; i++) {
        var item = list[i];
        if (item.type == 1) {
          //大图
          html +=
            '<div data-id="' +
            item.uniqueId +
            '"  class="__browser360_flow_adv_item" style="width: 100%; box-sizing: border-box; padding: 14px 15px;background:#fff;">';
          html +=
            ' <div style="font-size: 19px;line-height: 26px;color: #000;            text-overflow: ellipsis;display: -webkit-box;-webkit-line-clamp: 2;           -webkit-box-orient: vertical;overflow: hidden;"> ';
          html += item.desc;
          html += "</div> ";
          html +=
            ' <img style="border-radius:3px;display: block; width: 100%;min-height:86px;background:rgba(0,0,0,0.02);margin-top:9px;" src="' +
            item.imgList[0] +
            '"/>';
          html +=
            '<div style="display: flex;justify-content: space-between;align-items: center;margin-top: 7px;"> ';
          html +=
            ' <div style="display: flex;justify-content: flex-start;align-items: center;font-size: 12px; color: #999; line-height: 22px">';
          html +=
            '<div style="max-width: 130px;overflow: hidden;text-overflow: ellipsis;white-space: nowrap;">' +
            item.title +
            '</div><span style="margin-left: 9px">广告</span></div> ';
          html +=
            '<button id="__360browser_flow_item_btn_' +
            item.uniqueId +
            '" style="text-decoration: none;outline: none;border: 0;font-size: 12px;color: #4a90e2;background: none;">' +
            item.btnText +
            "</button> ";
          html += "</div> ";
          html += "</div> ";
        } else if (item.type == 2) {
          //小图
          html +=
            '<div  data-id="' +
            item.uniqueId +
            '"  class="__browser360_flow_adv_item"  style="background:#fff; display: -webkit-box;vertical-align: baseline;padding: 14px 15px 15px;">  ';

          html +=
            '<div style="width: 32.12%;margin: 5px 7px 4px 0;height: auto;position: relative;">';
          html +=
            '  <div style="width: 100%;padding-bottom: 66%;box-sizing: content-box;height: 0;overflow: hidden;">';

          html +=
            ' <img style="border-radius:3px;width: 100%; height: auto" src="' +
            item.imgList[0] +
            '"/>';
          html += "</div></div>";
          html +=
            '<div style="margin-left: 7px; -webkit-box-flex: 1;display: flex;flex-direction: column;justify-content: space-between;">  ';
          html +=
            ' <div style="font-size: 19px;line-height: 26px;color: #000;text-overflow: ellipsis;display: -webkit-box;-webkit-line-clamp: 2;-webkit-box-orient: vertical;overflow: hidden;">' +
            item.desc +
            "</div>";
          html +=
            '<div style="margin-top: 5px;display: flex;justify-content: space-between;align-items: center;">';
          html +=
            '<div style="display: flex;justify-content: flex-start;align-items: center;font-size: 12px; color: #999; line-height: 22px">';
          html +=
            '<div style=" max-width: 96px;overflow: hidden;text-overflow: ellipsis;white-space: nowrap;">' +
            item.title +
            '</div><span style="margin-left: 7px">广告</span></div>';
          html +=
            '   <button    id="__360browser_flow_item_btn_' +
            item.uniqueId +
            '"   style="text-decoration: none;outline: none;border: 0;font-size: 12px;color: #4a90e2;background: none;">' +
            item.btnText +
            "</button>";
          html += " </div>  ";
          html += " </div>  ";
          html += " </div>  ";
        } else if (item.type == 3) {
          //多图
          html +=
            '<div  data-id="' +
            item.uniqueId +
            '"  class="__browser360_flow_adv_item" style="background:#fff;width: 100%; box-sizing: border-box; padding: 14px 15px"> ';
          html +=
            '  <div style="font-size: 19px;line-height: 26px;color: #000;text-overflow: ellipsis;display: -webkit-box;-webkit-line-clamp: 2;            -webkit-box-orient: vertical;overflow: hidden;"> ' +
            item.desc +
            " </div>";
          html +=
            '  <div style="display: flex;justify-content: center;align-items: center;width: 100%;box-sizing: border-box;margin-top: 9px;overflow: hidden;">';
          html +=
            ' <img style="border-radius:3px;display: block; height: 70px;flex:1;background: rgba(0,0,0,0.02);" src="' +
            item.imgList[0] +
            '"/>';
          html +=
            ' <img style="border-radius:3px;display: block; height: 70px;flex:1;margin-left:7px;background: rgba(0,0,0,0.02);" src="' +
            item.imgList[1] +
            '"/>';
          html +=
            ' <img style="border-radius:3px;display: block;  height: 70px;flex:1;margin-left:7px;background: rgba(0,0,0,0.02);" src="' +
            item.imgList[2] +
            '"/>';
          html += "      </div> ";
          html +=
            '<div style="display: flex;justify-content: space-between;align-items: center;margin-top: 9px;">';
          html +=
            ' <div style="display: flex;justify-content: flex-start;align-items: center;font-size: 12px; color: #999; line-height: 22px"><div style=" max-width: 130px;overflow: hidden;text-overflow: ellipsis;white-space: nowrap;">' +
            item.title +
            '</div><span style="margin-left: 7px">广告</span></div> ';
          html +=
            '<button id="__360browser_flow_item_btn_' +
            item.uniqueId +
            '"  style="text-decoration: none;outline: none;            border: 0;font-size: 12px;color: #4a90e2;background: none;">' +
            item.btnText +
            "</button>";
          html += "</div> ";
          html += "</div> ";
        } else if (item.type == 4) {
          //无图
          html +=
            '  <div  data-id="' +
            item.uniqueId +
            '"  class="__browser360_flow_adv_item"  style="background:#fff;width: 100%;box-sizing: border-box;padding: 14px 15px;display: flex;flex-direction: column;justify-content: flex-start;"> ';
          html +=
            '  <div style="font-size: 19px;line-height: 26px;color: #000;text-overflow: ellipsis;display: -webkit-box;-webkit-line-clamp: 2;-webkit-box-orient: vertical;overflow: hidden;"> ' +
            item.desc +
            "</div>";
          html +=
            '   <div style="margin-top: 5px;display: flex;justify-content: space-between;align-items: center;"> ';
          html +=
            '  <div style="display: flex;justify-content: flex-start;align-items: center;font-size: 12px; color: #999; line-height: 22px"><div style="max-width: 130px;overflow: hidden;text-overflow: ellipsis;white-space: nowrap;">' +
            item.title +
            '</div><span style="margin-left: 7px">广告</span></div> ';
          html +=
            ' <button  id="__360browser_flow_item_btn_' +
            item.uniqueId +
            '"  style="text-decoration: none;outline: none;border: 0;font-size: 12px;color: #4a90e2;background: none;">' +
            item.btnText +
            "</button>";
          html += "</div> ";
          html += "</div> ";
        }

        //分割线
        html +=
          '  <div style="width: 100%; height: 1px; box-sizing: border-box; padding: 0 5px"> ';
        html +=
          '<div style="width: 100%; background: #f5f5f5; height: 1px"></div>';
        html += " </div>";
      }
      return html;
    },
    initPublic: function () {
      window.__360broser_flow_itemclick_callback = this.itemClickCallback.bind(
        this
      );
    },
    //元素是否在当前屏幕内
    isInScreen: function () {
      if (window.__360broser_flow_adv_showClocked) {
        //已经打过一次点
        return;
      }
      var container = document.getElementById(this.divId);
      if (container) {
        //获取位置
        var screenHeight = window.innerHeight;
        var y = container.getBoundingClientRect().top;
        if (y >= 0 && y <= screenHeight) {
          window.__360broser_flow_adv_showClocked = true;
          //在屏幕内
          console.log(
            '$adOnH5Event({"eventId":"shown_in_window", "has_ad":true})'
          );
        }
      }
    },
    //是否存在
    isExist: function () {
      //最多轮询20次，检测标记div是否存在
      var that = this;
      var index = 0;
      var intervalId = setInterval(function () {
        index++;
        if (index > 20) {
          clearInterval(intervalId);
          return;
        }
        //存在，则拼接html，复制
        container = document.getElementById(that.divId);
        if (container) {
          that.isInScreen();
          var data_index = container.getAttribute("data-index");
          console.log(
            '$adOnH5Event({"eventId":"found_container", "index":' +
              data_index +
              "})"
          ); //存在
          clearInterval(intervalId);
        }
      });
    },
    init: function (res) {
      var that = this;
      var container = null;
      this.res = res;
      this.initPublic();
      //最多轮询20次，检测标记div是否存在
      //存在，则拼接html，复制
      container = document.getElementById(that.divId);
      if (container) {
        container.innerHTML = that.initHtml();
        setTimeout(function () {
          that.addEvent();
        }, 600);
      }
    },
  };
  window.__Broser360_flow_adv_item = new __Broser360_flow_adv();
  // window.__Broser360_flow_adv_item.init(__ADS_ARRAY__); //渲染dom
  window.__Broser360_flow_adv_item.isExist(); //检测dom是否存在
})(window, undefined);
